/* imgmirc.dll is a plug-in for the mIRC application
* Copyright (C) 2003-2005 Ivan Zvolsky
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version. 
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library (lesser.txt)
*/
#include "stdafx.h"
#include "highlights.h"
#include "convthread.h"

const unsigned char * _hl_item::ctables;

std::vector<_hl_item *> hl_list;
_hl_item * hl_privmsg = NULL;
char hl_mainstr[3];

_hl_item::_hl_item ():ptrn(NULL),re(NULL),pe(NULL),ovector(NULL),np(0)
{
}

_hl_item::_hl_item (LPCTSTR _ptrn, BOOL flag):ptrn(NULL),re(NULL),pe(NULL),ovector(NULL),np(0)
{
	ptrn = (char *) malloc (strlen(_ptrn)+1);
	sprintf (ptrn, "%s", _ptrn);

	const char *error;
	int erroffset;
	re = pcre_compile(ptrn, 0, &error, &erroffset, ctables);
	//compiling a pattern:
	if (!re) throw 3;
	// studying a pattern:
	pe = pcre_study(re, 0, &error);
	// get number of subpatterns
	np = pcre_info (re, NULL, NULL);
	if (flag && np < 1) throw 3;
	ovector = (int*)malloc ((np+1)*3 * sizeof(int));

}

_hl_item::~_hl_item ()
{
	if (re) free (re);
	if (ptrn) free (ptrn);
	if (ovector) free (ovector);
	if (pe) free (pe);
}

int _hl_item::hl_exec (char * str, int len, int pos)
{
	return pcre_exec (re, pe, str, len,	pos, 0, ovector, (np+1)*3);
}



