/* imgmirc.dll is a plug-in for the mIRC application
* Copyright (C) 2003-2005 Ivan Zvolsky
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version. 
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library (lesser.txt)
*/
#include "stdafx.h"
#include "kbd_hook.h"
#include "convthread.h"

HHOOK hhk_kbd = NULL;

LRESULT CALLBACK GetKbdProc(
							int nCode,     // hook code
							WPARAM wParam, // virtual key code
							LPARAM lParam  // keystroke message information
							)

{
	if (nCode < 0) 
		return CallNextHookEx(hhk_kbd, nCode, wParam, lParam);
	else
	{
		switch ((lParam & 0xff0000)>>16)
		{
		case 0x2d: // x key
			if ( lParam & 0x20000000 ) // alt key pressed too 
			{
				SendMessage (mircWnd, WM_SYSCOMMAND, SC_MINIMIZE, 0);
				return 1;
			}
			break;
		}
	}
	return CallNextHookEx(hhk_kbd, nCode, wParam, lParam);
}