/* imgmirc.dll is a plug-in for the mIRC application
* Copyright (C) 2003-2005 Ivan Zvolsky
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version. 
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library (lesser.txt)
*/
#ifndef _MY_FUNCS_
#define _MY_FUNCS_

#include "convthread.h"
#include "winsock2.h"

#define NUM_FUNCS_OVERRIDEN		3

#define _RECV_FUNC_				0
#define _TEXTOUT_FUNC_			1
#define _DRAWTEXT_FUNC_			2

struct _func_tag
{
	DWORD * isd;
	DWORD old_func;
	DWORD new_func;
};

extern struct _func_tag func_tags[NUM_FUNCS_OVERRIDEN];

int WINAPI my_recv(SOCKET s, char FAR *buf, int len, int flags);

BOOL WINAPI my_SimpleExtTextOut(HDC, int, int, UINT, const RECT*, LPCTSTR, UINT, const int*);
BOOL WINAPI my_TranspExtTextOut(HDC, int, int, UINT, const RECT*, LPCTSTR, UINT, const int*);

int WINAPI my_SimpleDrawText(
							 HDC hDC,          // handle to DC
							 LPCTSTR lpchText, // text to draw
							 int nCount,       // text length
							 LPRECT lpRect,    // formatting dimensions
							 UINT uFormat      // text-drawing options
					   );

int WINAPI my_TransparentDrawText(
								  HDC hDC,          // handle to DC
								  LPCTSTR lpchText, // text to draw
								  int nCount,       // text length
								  LPRECT lpRect,    // formatting dimensions
								  UINT uFormat      // text-drawing options
								  );

void return_functions ();
int intercept_function( LPCTSTR module_name, 
					   LPCTSTR func_name, 
					   int num, 
					   DWORD new_func);
void do_intercept (void);

#endif
